---
title: Restore Activities
description: The POST {{apiPath}}/v1/environments/{{envID}}/activityRestores request restores activity data for the specified environment. Use this request to initiate data retrieval from cold storage, making it available for reading using the Read Activity Resources endpoint.
component: pingone-api
page_id: pingone-api:platform:audit-activities/post-restore-activities
canonical_url: https://developer.pingidentity.com/pingone-api/platform/audit-activities/post-restore-activities.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Restore Activities

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/activityRestores
```

The `POST {{apiPath}}/v1/environments/{{envID}}/activityRestores` request restores activity data for the specified environment. Use this request to initiate data retrieval from cold storage, making it available for reading using the [Read Activity Resources](get-read-activity-resources.html) endpoint.

See the [Audit](https://docs.pingidentity.com/pingone/monitoring/p1_reporting.html) section in the PingOne Admin guide for more information on activities retrieval.

> **Collapse: Request Model**
>
> | Property       | Type   | Required? |
> | -------------- | ------ | --------- |
> | `minTimestamp` | String | Required  |
> | `maxTimestamp` | String | Required  |
>
> For full property descriptions, refer to the [Audit reporting data model](../audit-activities.html).

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
"minTimestamp": "2025-09-01T00:00:00.000Z",
"maxTimestamp": "2025-09-17T00:09:59.999Z"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/activityRestores' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
"minTimestamp": "2025-09-01T00:00:00.000Z",
"maxTimestamp": "2025-09-17T00:09:59.999Z"
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/activityRestores")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"""minTimestamp"": ""2025-09-01T00:00:00.000Z""," + "\n" +
@"""maxTimestamp"": ""2025-09-17T00:09:59.999Z""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/activityRestores"
  method := "POST"

  payload := strings.NewReader(`{
"minTimestamp": "2025-09-01T00:00:00.000Z",
"maxTimestamp": "2025-09-17T00:09:59.999Z"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/activityRestores HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
"minTimestamp": "2025-09-01T00:00:00.000Z",
"maxTimestamp": "2025-09-17T00:09:59.999Z"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n\"minTimestamp\": \"2025-09-01T00:00:00.000Z\",\n\"maxTimestamp\": \"2025-09-17T00:09:59.999Z\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/activityRestores")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/activityRestores",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "minTimestamp": "2025-09-01T00:00:00.000Z",
    "maxTimestamp": "2025-09-17T00:09:59.999Z"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/activityRestores',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "minTimestamp": "2025-09-01T00:00:00.000Z",
    "maxTimestamp": "2025-09-17T00:09:59.999Z"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/activityRestores"

payload = json.dumps({
  "minTimestamp": "2025-09-01T00:00:00.000Z",
  "maxTimestamp": "2025-09-17T00:09:59.999Z"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/activityRestores');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n"minTimestamp": "2025-09-01T00:00:00.000Z",\n"maxTimestamp": "2025-09-17T00:09:59.999Z"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/activityRestores")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "minTimestamp": "2025-09-01T00:00:00.000Z",
  "maxTimestamp": "2025-09-17T00:09:59.999Z"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n\"minTimestamp\": \"2025-09-01T00:00:00.000Z\",\n\"maxTimestamp\": \"2025-09-17T00:09:59.999Z\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/activityRestores")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.test-one-pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/activityRestores/67865362-d613-4ee8-b59b-6f6077a3125b"
        }
    },
    "id": "67865362-d613-4ee8-b59b-6f6077a3125b",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "minTimestamp": "2025-09-01T00:00:00.000Z",
    "maxTimestamp": "2025-09-17T00:09:59.999Z",
    "status": "PENDING"
}
```
